#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <rtl_fifo.h>
#include <rtl_time.h>
#include <mbuff.h>
#include <signal.h>
#include <math.h>

#include "clcont.h"

volatile struct my_msg_struct * msg;

int
main(int argc, char *argv[])
{
	char c;

	if((msg = (volatile struct my_msg_struct*) mbuff_alloc("msg", sizeof(struct my_msg_struct))) == NULL){
		fprintf(stderr, "mbuff_alloc failed \n");
		return -1;
	}
	
	msg->freq = FREQ0;
	msg->amp1 = AMP0;
	msg->amp2 = AMP0;
	msg->phase = PHASE0;
	msg->gain = 0;
	msg->delay = 0;
	
	printf("----- menu -----\n");
	printf("f,F ... Frequency\n");
	printf("a,A ... Amp. for SPK1\n");
	printf("b,B ... Amp. for SPK2\n");
	printf("p,P ... Phase\n");
	printf("g,G ... gain for feedback controller\n");
	printf("d,D ... delay for feedback controller\n");
	printf("q ... quit\n");

	system("stty raw -echo");
	//	setvbuf(stdout, NULL, _IONBF, 0);
	setvbuf(stdin, NULL, _IONBF, 0);

	while(1){
		//		fprintf(stderr, "Freq: %7f Amp1:%7f Amp2:%7f Phase:%7f\r", msg->freq, msg->amp1, msg->amp2, msg->phase);
		fprintf(stderr, "Freq: %.2f Amp1:%.2f Amp2:%.2f Phase:%.2f gain:%.2f delay:%3d(*0.2ms)\r", msg->freq, msg->amp1, msg->amp2, msg->phase, msg->gain, msg->delay);
		read(0, &c, 1);

		if(c == 'q') break;

		switch(c){
		case 'f':
                        if(msg->freq > FREQ_MIN) msg->freq -= FREQ_STEP;
			break;
			
		case 'F':
                        if(msg->freq < FREQ_MAX) msg->freq += FREQ_STEP;
			break;
			
		case 'a':
			msg->amp1 -= AMP_STEP;
			if(msg->amp1 < AMP_MIN) msg->amp1 = AMP_MIN;
			break;
			
		case 'A':
			msg->amp1 += AMP_STEP;
			if(msg->amp1 > AMP_MAX) msg->amp1 = AMP_MAX;
			break;
			
		case 'b':
			msg->amp2 -= AMP_STEP;
			if(msg->amp2 < AMP_MIN) msg->amp2 = AMP_MIN;
			break;
			
		case 'B':
			msg->amp2 += AMP_STEP;
			if(msg->amp2 > AMP_MAX) msg->amp2 = AMP_MAX;
			break;
			
		case 'p':
			if(msg->phase > PHASE_MIN) msg->phase -= PHASE_STEP;
			break;
			
		case 'P':
			if(msg->phase < PHASE_MAX) msg->phase += PHASE_STEP;
			break;
			
		case 'g':
			msg->gain -= GAIN_STEP;
			if(msg->gain < GAIN_MIN) msg->gain = GAIN_MIN;
			break;
				
		case 'G':
			msg->gain += GAIN_STEP;
			if(msg->gain > GAIN_MAX) msg->gain = GAIN_MAX;
			break;
				
		case 'd':
			if(msg->delay > DELAY_MIN) msg->delay -= DELAY_STEP;
			break;
				
		case 'D':
			if(msg->delay < DELAY_MAX) msg->delay += DELAY_STEP;
			break;
			
		default:
			break;
			
		}

	}

	system("stty -raw echo");
	putchar('\n');

	msg->freq = 0.0;
	msg->amp1 = 0.0;
	msg->amp2 = 0.0;
	msg->phase = 0.0;

	mbuff_free("msg", (void*)msg);

	return 0;
}
